unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Novator2, StdCtrls, Buttons, Mask, Grids;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    MaskEdit1: TMaskEdit;
    BitBtn1: TBitBtn;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    StringGrid1: TStringGrid;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
      procedure WndProc(var Msg: TMessage); override;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
  private
    { Private declarations }
    procedure GetDescriptObject(ObjNumber:Integer; flEdit:Boolean);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

procedure TForm1.GetDescriptObject(ObjNumber:Integer; flEdit:Boolean);
  var Obj:TNObject;
      i:Integer;
      CP:Integer;
begin
Obj := TNObject.Create(ObjNumber);
if flEdit then
  CP := Obj.Points.Count - 1
else
  CP := Obj.Points.Count;

StringGrid1.RowCount := CP + 1;
for i:=1 to CP do
    Begin
    StringGrid1.Cells[0,i] := IntToStr(i);
    StringGrid1.Cells[1,i] := FloatToStr(Obj.Points.GetOfNumber(i).X );
    StringGrid1.Cells[2,i] := FloatToStr(Obj.Points.GetOfNumber(i).Y);
    StringGrid1.Cells[3,i] := FloatToStr(Obj.Points.GetOfNumber(i).Z);
    End;
end;



{$R *.dfm}
procedure TForm1.WndProc(var Msg: TMessage);
var i:Integer;
    Map:TNMap;
begin
  inherited;
  if (Msg.Msg =  WM_MYMOUSEHOOK) or (Msg.Msg = WM_MYKEYHOOK) then
    Begin
    RTEngineStream.Resume;
    End;

  case Msg.Msg of
  WM_DIGITALS_START_EDIT:
      Begin
      Label4.Caption := '1';
      ComboBox1.ItemIndex := 2;
      ComboBox2.Items.Clear;
      ComboBox2.Items.Add(IntToStr(Msg.WParam));
      ComboBox2.ItemIndex := 0;
      if ComboBox2.Text <> '' then
          GetDescriptObject(StrToInt(ComboBox2.Text),True);
      End;
  WM_DIGITALS_ADD_POINT:
      Begin
      if ComboBox2.Text <> '' then
          GetDescriptObject(StrToInt(ComboBox2.Text),True);
      End;
  WM_DIGITALS_DELETE_POINT:
      Begin
      if ComboBox2.Text <> '' then
          GetDescriptObject(StrToInt(ComboBox2.Text),True);
      End;
  WM_DIGITALS_STOP_EDIT:
      Begin
      if ComboBox2.Text <> '' then
          GetDescriptObject(StrToInt(ComboBox2.Text),True);
      End;
  WM_DIGITALS_SELECT_OBJECT:
      Begin
      ComboBox1.ItemIndex := 1;
      Map := TNMap.Create();
      ComboBox2.Items.Clear;
      for i:=1 to Map.SelectedObjects.Count do
          ComboBox2.Items.Add(IntToStr(Map.SelectedObjects.GetObject(i).MemberNumber));
      ComboBox2.ItemIndex := 0;
      Label4.Caption := IntToStr(ComboBox2.Items.Count);
      if ComboBox2.Text <> '' then
          GetDescriptObject(StrToInt(ComboBox2.Text),False);
      End;
  End;

end;



procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  TRY
    NovatorStart(Self,StrToInt(MaskEdit1.Text),False,True,True)
  EXCEPT
    On E:EAbort do ShowMessage(E.Message)
  END;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
StringGrid1.Cells[0,0] := ' ';
StringGrid1.Cells[1,0] := ' ';
StringGrid1.Cells[2,0] := ' Y';
StringGrid1.Cells[3,0] := ' Z';
end;

procedure TForm1.ComboBox2Change(Sender: TObject);
begin
if ComboBox2.Text <> '' then
    GetDescriptObject(StrToInt(ComboBox2.Text),False);
end;

end.
